`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 12/11/2023 10:07:39 PM
// Design Name: 
// Module Name: ram
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
module ram(
        clk,
        oe,
        we,
        addr,
        in,
        out,
        disp_out
    );

parameter width = 16;
parameter depth = 10;
parameter addr_width = 12;

input clk;
input oe;
input we;
input [addr_width-1 : 0]    addr;
input [width-1 : 0]         in;
output[width-1 : 0]         out;
output[width-1 : 0]         disp_out;

reg [width-1 : 0]           regs[depth-1 : 0];

reg [addr_width : 0]        i;

//WRITE Memory program
initial begin
    for(i = 0; i < depth; i = i + 1)
        regs[i] <= 0;
    
    regs[0] <= 'h300C ; //Add Y
    regs[1] <= 'h6000 ; //Output
    regs[2] <= 'h0006 ; //JnS AddSome
    regs[3] <= 'h300C ; //Add Y
    regs[4] <= 'h6000 ; //Output
    regs[5] <= 'h7000 ; //Halt
    regs[6] <= 'h0000 ; //AddSome, HEX 000
    regs[7] <= 'h100B ; //         Load X
    regs[8] <= 'h300C ; //         Add Y
    regs[9] <= 'h6000 ; //         Output
    regs[10]<= 'hC006 ; //         JumpI AddSome
    regs[11]<= 'h002A ; // X = 42
    regs[12]<= 'h0005 ; // Y  = 5
end

always @(posedge clk) begin
    if(we)
        regs[addr] <= in;
end

assign out = oe ? regs[addr] : 0;
assign disp_out = regs[addr];

endmodule